function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React from "react";
import { memo, forwardRef, useContext, useState, useEffect, useMemo, useCallback, useRef } from 'react';
import { createNamespace, classNames, setDefaultProps } from '../_util';
import PropTypes from 'prop-types';
import formContext from '../form/formContext';
import Picker from '../picker';
import AsyncValidator from 'async-validator';
var _createNamespace = createNamespace('area'),
  name = _createNamespace.name,
  bem = _createNamespace.bem;
var Area = /*#__PURE__*/forwardRef(function (props, ref) {
  var title = props.title,
    detailTitle = props.detailTitle,
    name = props.name,
    placeholder = props.placeholder,
    prepend = props.prepend,
    append = props.append,
    labelPosition = props.labelPosition,
    textPosition = props.textPosition,
    labelWidth = props.labelWidth,
    cancelBtnText = props.cancelBtnText,
    confirmBtnText = props.confirmBtnText,
    areaList = props.areaList,
    areaValues = props.areaValues,
    rules = props.rules,
    required = props.required,
    onConfirm = props.onConfirm,
    onCancel = props.onCancel;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    _labelWidth = _useState2[0],
    setLabelWidth = _useState2[1];
  var _useState3 = useState(areaValues.slice(0, 3)),
    _useState4 = _slicedToArray(_useState3, 2),
    _cityValues = _useState4[0],
    setCityValues = _useState4[1];
  var _useState5 = useState(areaValues[3] || ''),
    _useState6 = _slicedToArray(_useState5, 2),
    _detailValue = _useState6[0],
    setDetailValue = _useState6[1];
  var _useState7 = useState(false),
    _useState8 = _slicedToArray(_useState7, 2),
    _detailFocused = _useState8[0],
    setDetailFocused = _useState8[1];
  var _useState9 = useState(true),
    _useState10 = _slicedToArray(_useState9, 2),
    _showMessage = _useState10[0],
    setShowMessage = _useState10[1];
  var _useState11 = useState(''),
    _useState12 = _slicedToArray(_useState11, 2),
    _validateMessage = _useState12[0],
    setValidateMessage = _useState12[1];
  var _fieldRules = [].concat(rules || [{
    required: true,
    message: "".concat(detailTitle, "\u4E0D\u80FD\u4E3A\u7A7A")
  }]);
  var _isRequired = required == false ? false : _fieldRules.some(function (item) {
    return item.required == true;
  });
  var form = useContext(formContext);
  var pickerRef = useRef();
  var areaEl = null;
  var _this = useRef({});
  useEffect(function () {
    setCityValues(areaValues.slice(0, 3));
    setDetailValue(areaValues[3] || '');
  }, [areaValues]);
  var handleClearClick = function handleClearClick(e) {
    return setDetailValue('');
  };
  var handlePickerClick = function handlePickerClick() {
    return pickerRef.current.show();
  };
  var handlePickerConfirm = useCallback(function (values) {
    values.length = 3;
    setCityValues(values.map(function (item) {
      return item.text || item.title;
    }));
    setValidateMessage('');
    onConfirm(values);
  }, []);
  var handlePickerCancel = useCallback(function (values) {
    return onCancel(values);
  }, []);
  var handlePickerChange = useCallback(function (values) {}, []);
  var handleDetailFocus = function handleDetailFocus(e) {
    return setDetailFocused(true);
  };
  var handleDetailBlur = function handleDetailBlur(e) {
    return setTimeout(function () {
      return setDetailFocused(false);
    }, 200);
  };
  var handleDetailChange = function handleDetailChange(e) {
    setValidateMessage('');
    setDetailValue(e.target.value);
  };
  var getFilterRules = function getFilterRules(trigger) {
    return _fieldRules.filter(function (rule) {
      return !rule.trigger || rule.trigger.indexOf(trigger) != -1;
    });
  };
  var validate = function validate(trigger) {
    var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
    var rules = getFilterRules(trigger);
    if (!_isRequired) {
      callback('');
      return;
    }
    var validateMessage = '';
    if (_cityValues.join('').length == 0) {
      validateMessage = '请选择省份';
      callback(validateMessage);
      setValidateMessage(validateMessage);
      return false;
    }
    var descriptor = {};
    var prop = 'detail';
    descriptor[prop] = rules;
    var validator = new AsyncValidator(descriptor);
    var model = {};
    model[prop] = _detailValue;
    validator.validate(model).then(function () {
      validateMessage = '';
      setValidateMessage(validateMessage);
      callback(validateMessage);
    }).catch(function (_ref) {
      var errors = _ref.errors,
        fields = _ref.fields;
      validateMessage = errors[0].message || 'error';
      setValidateMessage(validateMessage);
      callback(validateMessage);
    });
  };
  var getValue = function getValue() {
    return {
      name: name,
      value: (_cityValues.join(" ") + " " + _detailValue).trim(),
      title: title
    };
  };
  var resetField = function resetField() {
    pickerRef.current.resetField();
    setCityValues(areaValues.slice(0, 3));
    setDetailValue(areaValues[3] || '');
    setValidateMessage('');
  };

  // 给'this'添加方法，供form调用
  Object.assign(_this.current, {
    getValue: getValue,
    validate: validate,
    resetField: resetField
  });
  useEffect(function () {
    _this.current.$el = areaEl;
    form.addField(_this.current);
    setLabelWidth(labelWidth || form.labelWidth || '');
  }, []);
  console.log('area mounted or update');
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(['form-item', bem()]),
    ref: function ref(el) {
      return areaEl = el;
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: bem('inner')
  }, /*#__PURE__*/React.createElement("label", {
    className: bem('label', {
      'text-right': labelPosition == 'right'
    }),
    style: {
      width: _labelWidth
    }
  }, title), prepend && /*#__PURE__*/React.createElement("div", {
    className: bem('prepend')
  }, prepend), /*#__PURE__*/React.createElement("div", {
    className: bem('content'),
    onClick: handlePickerClick
  }, /*#__PURE__*/React.createElement("div", {
    className: bem('select', {
      'text-right': textPosition == 'right',
      placeholder: _cityValues.join('').length == 0
    })
  }, _cityValues.join('-').length > 0 ? _cityValues.join('-') : '请选择省市区'), /*#__PURE__*/React.createElement("div", {
    className: bem('arrow-right')
  }, /*#__PURE__*/React.createElement("svg", {
    width: "1em",
    height: "1em",
    viewBox: "0 0 6 10"
  }, /*#__PURE__*/React.createElement("g", {
    stroke: "none",
    strokeWidth: "1",
    fill: "none",
    fillRule: "evenodd"
  }, /*#__PURE__*/React.createElement("g", {
    transform: "translate(-350.000000, -20.000000)",
    fill: "currentColor"
  }, /*#__PURE__*/React.createElement("g", null, /*#__PURE__*/React.createElement("g", {
    transform: "translate(346.000000, 18.000000)"
  }, /*#__PURE__*/React.createElement("g", {
    transform: "translate(7.000000, 7.000000) rotate(-270.000000) translate(-7.000000, -7.000000) translate(2.750000, 4.500000)"
  }, /*#__PURE__*/React.createElement("path", {
    d: "M6.53188022,3.0259328 L3.02129527,6.5321515 C2.73046889,6.82261617 2.25894616,6.82261617 1.96811978,6.5321515 C1.67729341,6.24168683 1.67729341,5.77075056 1.96811978,5.48028589 L4.95211699,2.5 L1.96811978,-0.480285891 C1.67729341,-0.770750558 1.67729341,-1.24168683 1.96811978,-1.5321515 C2.25894616,-1.82261617 2.73046889,-1.82261617 3.02129527,-1.5321515 L6.53188022,1.9740672 C6.82270659,2.26453186 6.82270659,2.73546814 6.53188022,3.0259328 Z",
    fillRule: "nonzero",
    transform: "translate(4.250000, 2.500000) rotate(-90.000000) translate(-4.250000, -2.500000) "
  }))))))))), /*#__PURE__*/React.createElement(Picker, {
    columns: areaList,
    columnsValue: areaValues,
    cancelBtnText: cancelBtnText,
    confirmBtnText: confirmBtnText,
    onConfirm: handlePickerConfirm,
    onCancel: handlePickerCancel,
    onChange: handlePickerChange,
    ref: pickerRef
  }), append && /*#__PURE__*/React.createElement("div", {
    className: bem('append')
  }, append)), /*#__PURE__*/React.createElement("div", {
    className: bem('detail', {
      hide: _cityValues.join('').length == 0
    })
  }, /*#__PURE__*/React.createElement("label", {
    className: bem('label', {
      'text-right': labelPosition == 'right'
    }),
    style: {
      width: _labelWidth
    }
  }, detailTitle), /*#__PURE__*/React.createElement("input", {
    className: bem('input', {
      'text-right': textPosition == 'right'
    }),
    type: "text",
    name: "detail",
    placeholder: placeholder,
    value: _detailValue,
    autoComplete: "off",
    onChange: handleDetailChange,
    onFocus: handleDetailFocus,
    onBlur: handleDetailBlur
  }), /*#__PURE__*/React.createElement("a", {
    className: bem('clear', {
      show: _detailValue && _detailFocused
    }),
    onClick: handleClearClick
  }, /*#__PURE__*/React.createElement("svg", {
    width: "1em",
    height: "1em",
    viewBox: "0 0 13 13"
  }, /*#__PURE__*/React.createElement("g", {
    stroke: "none",
    strokeWidth: "1",
    fill: "none",
    fillRule: "evenodd"
  }, /*#__PURE__*/React.createElement("g", {
    transform: "translate(-347.000000, -16.000000)",
    fill: "currentColor",
    fillRule: "nonzero"
  }, /*#__PURE__*/React.createElement("path", {
    d: "M359.127301,19.2498723 C358.537222,18.2437191 357.756193,17.4627605 356.749987,16.8726113 C355.755019,16.2890502 354.673613,16 353.499991,16 C352.326369,16 351.241123,16.2824796 350.234952,16.8726113 C349.239967,17.4561724 348.462778,18.2437191 347.872682,19.2498723 C347.289173,20.2449454 347,21.326369 347,22.4999031 C347,23.6736134 347.282603,24.7587186 347.872682,25.7650303 C348.45619,26.7599449 349.239967,27.5436339 350.234952,28.1272126 C351.24114,28.7173618 352.326387,28.9999824 353.499991,28.9999824 C354.673596,28.9999824 355.755019,28.7107737 356.749987,28.1272126 C357.756175,27.5370634 358.543775,26.7599449 359.127301,25.7650303 C359.717397,24.7587186 360,23.6736134 360,22.4999031 C360,21.326369 359.710827,20.2449454 359.127301,19.2498723 Z M356.644682,24.862244 L355.847236,25.6446647 L353.500009,23.2823238 L351.1528,25.6446647 L350.355353,24.862244 L352.717623,22.4999031 L350.355353,20.1526586 L351.137756,19.3553177 L353.500009,21.7175 L355.847218,19.3553177 L356.644665,20.1526586 L354.282394,22.4999031 L356.644682,24.862244 Z"
  })))))), _validateMessage && /*#__PURE__*/React.createElement("div", {
    className: bem('error')
  }, _validateMessage));
});
setDefaultProps(Area, {
  title: {
    type: PropTypes.string,
    default: '标题'
  },
  detailTitle: {
    type: PropTypes.string,
    default: ''
  },
  labelWidth: {
    type: PropTypes.string
  },
  labelPosition: {
    type: PropTypes.oneOf(['left', 'right'])
  },
  textPosition: {
    type: PropTypes.oneOf(['left', 'right']),
    default: 'left'
  },
  prepend: {
    type: PropTypes.node
  },
  append: {
    type: PropTypes.node
  },
  showMessage: {
    type: PropTypes.bool,
    default: true
  },
  cancelBtnText: {
    type: PropTypes.node
  },
  confirmBtnText: {
    type: PropTypes.node
  },
  onConfirm: {
    type: PropTypes.func,
    default: function _default() {}
  },
  onCancel: {
    type: PropTypes.func,
    default: function _default() {}
  },
  // 省市县数据，二维数组 [[省], [市], [县]]
  areaList: {
    type: PropTypes.array,
    default: []
  },
  // 省市县选择的值['浙江省', '绍兴市', '上虞区']
  areaValues: {
    type: PropTypes.array,
    default: []
  },
  rules: {
    type: PropTypes.array
  },
  required: {
    type: PropTypes.bool,
    default: true
  },
  placeholder: {
    type: PropTypes.string,
    default: '具体到门牌号，最少4个字符'
  }
});
export default /*#__PURE__*/memo(Area);