function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
import React from 'react';
import PropTypes from 'prop-types';
import Picker from 'better-picker';
import memoize from "memoize-one";
import { setDefaultProps, classNames } from '../_util/assist';
import { Consumer } from '../form/formContext';
var prefixCls = 'r-datepicker';
var DatePicker = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DatePicker, _React$PureComponent);
  var _super = _createSuper(DatePicker);
  function DatePicker(props) {
    var _this;
    _classCallCheck(this, DatePicker);
    _this = _super.call(this, props);
    _this.placeholderText = memoize(function (value) {
      var _this$generateResult = _this.generateResult(),
        text = _this$generateResult.text;
      var placeholder = _this.props.placeholder;
      if (placeholder === undefined && _this.form && _this.form.props.placeholder) placeholder = _this.form.props.placeholder;
      if (placeholder === undefined) placeholder = '请选择';
      return value === '' ? placeholder : text;
    });
    _this.initPickerData = memoize(function (value, columnsOrder) {
      var isValidDate = !isNaN(new Date(value).getTime());
      var today = isValidDate ? new Date(value) : new Date();
      var thisYear = today.getFullYear();
      var thisMonth = today.getMonth();
      var thisDay = today.getDate();
      _this._state.thisYear = thisYear;
      var time = {
        year: _this.generateYearData(),
        month: _this.generateMonthData(),
        day: _this.generateDayData(_this.getMaxDate(thisYear, thisMonth))
      };
      var timeSelectedIndex = {
        year: time.year.findIndex(function (item) {
          return item.value * 1 === thisYear;
        }),
        month: time.month.findIndex(function (item) {
          return item.value * 1 === thisMonth + 1;
        }),
        day: time.day.findIndex(function (item) {
          return item.value * 1 === thisDay;
        })
      };
      _this._state.pickerData = columnsOrder.map(function (item) {
        return time[item];
      });
      _this._state.pickerSelectedIndex = columnsOrder.map(function (item) {
        return timeSelectedIndex[item] < 0 ? 0 : timeSelectedIndex[item];
      });
      // 查找year、month、day 在columnsOrder的索引
      for (var i = 0; i < columnsOrder.length; i++) {
        var type = columnsOrder[i];
        if (type === 'year') {
          _this._state.yearIndexInColumnsOrder = i;
        } else if (type === 'month') {
          _this._state.monthIndexInColumnsOrder = i;
        } else if (type === 'day') {
          _this._state.dayIndexInColumnsOrder = i;
        }
      }
      // 异步数据时更新picker
      if (_this._state.picker) {
        _this.removePiker();
        _this.showPicker();
      }
    });
    _this.showPicker = function (e) {
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        pickerTitle = _this$props.pickerTitle,
        pickerCancelBtnText = _this$props.pickerCancelBtnText,
        pickerConfirmBtnText = _this$props.pickerConfirmBtnText,
        mode = _this$props.mode;
      if (disabled) return;
      var _this$_state = _this._state,
        pickerData = _this$_state.pickerData,
        pickerSelectedIndex = _this$_state.pickerSelectedIndex;
      var _pickerCancelBtnText = pickerCancelBtnText || _this.form && _this.form.props.datePickerCancelBtnText;
      var _pickerConfirmBtnText = pickerConfirmBtnText || _this.form && _this.form.props.datePickerConfirmBtnText;
      var _mode = mode || _this.form && _this.form.props.mode || 'default';
      var picker = new Picker({
        data: pickerData,
        selectedIndex: pickerSelectedIndex,
        title: pickerTitle
      });
      pickerCancelBtnText && (picker.cancelEl.innerHTML = _pickerCancelBtnText);
      pickerConfirmBtnText && (picker.confirmEl.innerHTML = _pickerConfirmBtnText);
      picker.pickerEl.setAttribute('mode', _mode);
      picker.on('picker.change', function (index, selectedIndex) {
        _this._state.pickerSelectedIndex[index] = selectedIndex;
        // 年或月变化时更新天数
        if ((index === _this._state.yearIndexInColumnsOrder || index === _this._state.monthIndexInColumnsOrder) && _this._state.monthIndexInColumnsOrder > -1) {
          _this.refillDates();
        }
      });
      picker.on('picker.select', function (index, selectedIndex) {
        _this.onConfirm();
        _this.removePiker();
      });
      picker.on('picker.cancel', function () {
        _this.removePiker();
        _this.props.onCancel();
      });
      picker.maskEl.onclick = function () {
        picker.trigger('picker.cancel');
      };
      picker.show();
      _this._state.picker = picker;
    };
    _this.state = {
      value: props.value,
      prePropsValue: props.value,
      count: 0
    };
    _this._state = {
      picker: null,
      pickerData: [],
      pickerSelectedIndex: [],
      yearIndexInColumnsOrder: -1,
      monthIndexInColumnsOrder: -1,
      dayIndexInColumnsOrder: -1
    };
    return _this;
  }
  _createClass(DatePicker, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removePiker();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        children = _this$props2.children,
        columnsOrder = _this$props2.columnsOrder,
        className = _this$props2.className,
        mode = _this$props2.mode;
      var value = this.state.value;
      this.initPickerData(value, columnsOrder);
      return /*#__PURE__*/React.createElement(Consumer, null, function (context) {
        _this2.form = context;
        console.log('DatePicker mounted or updated');
        var placeholderText = _this2.placeholderText(value);
        return /*#__PURE__*/React.createElement("div", {
          className: _this2.wrapCls,
          onClick: _this2.showPicker
        }, children ? children : placeholderText);
      });
    }
  }, {
    key: "wrapCls",
    get: function get() {
      var _this$props3 = this.props,
        className = _this$props3.className,
        readonly = _this$props3.readonly,
        disabled = _this$props3.disabled;
      var value = this.state.value;
      var _mode = this.props.mode || this.form && this.form.props.mode || 'default';
      return classNames(["".concat(prefixCls), "".concat(prefixCls, "-mode-").concat(_mode), className, _defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-empty"), value === ''), "".concat(prefixCls, "-disabled"), !!disabled), "".concat(prefixCls, "-readonly"), !!readonly)]);
    }
  }, {
    key: "removePiker",
    value: function removePiker() {
      var picker = this._state.picker;
      if (picker && picker.pickerEl) {
        picker.pickerEl.parentNode.removeChild(picker.pickerEl);
        this._state.picker = null;
      }
    }
  }, {
    key: "refillDates",
    value: function refillDates() {
      var _this$_state2 = this._state,
        pickerData = _this$_state2.pickerData,
        yearIndexInColumnsOrder = _this$_state2.yearIndexInColumnsOrder,
        monthIndexInColumnsOrder = _this$_state2.monthIndexInColumnsOrder,
        dayIndexInColumnsOrder = _this$_state2.dayIndexInColumnsOrder,
        pickerSelectedIndex = _this$_state2.pickerSelectedIndex;
      var thisYear = pickerData[yearIndexInColumnsOrder][pickerSelectedIndex[yearIndexInColumnsOrder]].value;
      var thisMonth = pickerData[monthIndexInColumnsOrder][pickerSelectedIndex[monthIndexInColumnsOrder]].value;
      var maxDate = this.getMaxDate(thisYear, thisMonth - 1);
      var dates = this.generateDayData(maxDate);
      var dateSelectedIndex = pickerSelectedIndex[dayIndexInColumnsOrder];
      this._state.picker.refillColumn(dayIndexInColumnsOrder, dates);
      if (dateSelectedIndex > maxDate - 1) {
        pickerSelectedIndex[dayIndexInColumnsOrder] = maxDate - 1;
        this._state.picker.scrollColumn(dayIndexInColumnsOrder, pickerSelectedIndex[dayIndexInColumnsOrder]);
      }
    }
  }, {
    key: "onConfirm",
    value: function onConfirm() {
      var _this3 = this;
      var _this$generateResult2 = this.generateResult(),
        year = _this$generateResult2.year,
        month = _this$generateResult2.month,
        day = _this$generateResult2.day,
        text = _this$generateResult2.text,
        value = _this$generateResult2.value;
      this.setState({
        value: value
      }, function () {
        _this3.props.onConfirm({
          year: year.value,
          month: month.value,
          day: day.value,
          date: day.value,
          text: text,
          value: value
        });
      });
    }
  }, {
    key: "generateYearData",
    value: function generateYearData() {
      var _this$props4 = this.props,
        startYear = _this$props4.startYear,
        endYear = _this$props4.endYear,
        offsetYear = _this$props4.offsetYear,
        yearsLength = _this$props4.yearsLength,
        pickerFormatter = _this$props4.pickerFormatter;
      startYear = (startYear * 1 || this._state.thisYear) + offsetYear * 1;
      yearsLength = yearsLength * 1;
      yearsLength = Math.max(yearsLength, 1);
      endYear = endYear * 1 || startYear + yearsLength;
      return new Array(endYear - startYear).fill('').map(function (item, index) {
        var year = startYear + index;
        return {
          text: "".concat(pickerFormatter && pickerFormatter('year', year) || year),
          value: "".concat(year)
        };
      });
    }
  }, {
    key: "generateMonthData",
    value: function generateMonthData() {
      var _this$props5 = this.props,
        language = _this$props5.language,
        pickerFormatter = _this$props5.pickerFormatter;
      var en = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
      var id = ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'];
      var result = [];
      for (var i = 0; i < 12; i++) {
        var text = this.valueFormatTwoDigitInteger(i + 1);
        if (language === 'en') {
          text = en[i];
        } else if (language === 'id') {
          text = id[i];
        }
        result.push({
          text: "".concat(pickerFormatter && pickerFormatter('month', text) || text),
          value: this.valueFormatTwoDigitInteger(i + 1)
        });
      }
      return result;
    }
  }, {
    key: "generateDayData",
    value: function generateDayData() {
      var maxDate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 31;
      var pickerFormatter = this.props.pickerFormatter;
      var result = [];
      for (var i = 1; i <= maxDate; i++) {
        var day = this.valueFormatTwoDigitInteger(i);
        result.push({
          text: "".concat(pickerFormatter && pickerFormatter('day', day) || day),
          value: day
        });
      }
      return result;
    }
  }, {
    key: "generateResult",
    value: function generateResult() {
      var _this$props6 = this.props,
        textFormat = _this$props6.textFormat,
        valueFormat = _this$props6.valueFormat;
      var _this$_state3 = this._state,
        pickerData = _this$_state3.pickerData,
        pickerSelectedIndex = _this$_state3.pickerSelectedIndex,
        yearIndexInColumnsOrder = _this$_state3.yearIndexInColumnsOrder,
        monthIndexInColumnsOrder = _this$_state3.monthIndexInColumnsOrder,
        dayIndexInColumnsOrder = _this$_state3.dayIndexInColumnsOrder;
      var year = yearIndexInColumnsOrder > -1 ? pickerData[yearIndexInColumnsOrder][pickerSelectedIndex[yearIndexInColumnsOrder]] : {};
      var month = monthIndexInColumnsOrder > -1 ? pickerData[monthIndexInColumnsOrder][pickerSelectedIndex[monthIndexInColumnsOrder]] : {};
      var day = dayIndexInColumnsOrder > -1 ? pickerData[dayIndexInColumnsOrder][pickerSelectedIndex[dayIndexInColumnsOrder]] : {};
      var text = typeof textFormat == 'function' ? textFormat({
        year: year,
        month: month,
        day: day
      }) : textFormat.replace('yyyy', year.text).replace('mm', month.value).replace('dd', day.value).replace(/\/undefined/g, '');
      var value = typeof valueFormat == 'function' ? valueFormat({
        year: year,
        month: month,
        day: day
      }) : valueFormat.replace('yyyy', year.value).replace('mm', month.value).replace('dd', day.value).replace(/\/undefined/g, '');
      return {
        year: year,
        month: month,
        day: day,
        value: value,
        text: text
      };
    }
  }, {
    key: "getMaxDate",
    value: function getMaxDate(year, month) {
      // month 从0开始
      return new Date(new Date(year, month + 1, 1) - 1).getDate();
    }
  }, {
    key: "valueFormatTwoDigitInteger",
    value: function valueFormatTwoDigitInteger(value) {
      value = value.toString();
      return (value.length === 1 ? '0' : '') + value;
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.value !== prevState.prePropsValue) {
        return {
          value: nextProps.value,
          prePropsValue: nextProps.value
        };
      }
      return null;
    }
  }]);
  return DatePicker;
}(React.PureComponent);
setDefaultProps(DatePicker, {
  value: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    default: ''
  },
  startYear: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
  },
  endYear: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
  },
  offsetYear: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    default: 0
  },
  yearsLength: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    default: 10
  },
  columnsOrder: {
    type: PropTypes.array,
    default: ['year', 'month', 'day']
  },
  language: {
    type: PropTypes.string,
    default: 'zh' // 中文 'zh'、 英文 'en'、 印尼 'id'
  },

  placeholder: {
    type: PropTypes.string
  },
  disabled: {
    type: PropTypes.oneOf(['disabled', 1, 0, true, false])
  },
  readonly: {
    type: PropTypes.oneOf(['readonly', 1, 0, true, false])
  },
  textFormat: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
    default: 'yyyy/mm/dd'
  },
  valueFormat: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
    default: 'yyyy/mm/dd'
  },
  pickerFormatter: {
    type: PropTypes.func
  },
  pickerTitle: {
    type: PropTypes.string
  },
  pickerCancelBtnText: {
    type: PropTypes.string
  },
  pickerConfirmBtnText: {
    type: PropTypes.string
  },
  onConfirm: {
    type: PropTypes.func,
    default: function _default() {}
  },
  onCancel: {
    type: PropTypes.func,
    default: function _default() {}
  },
  mode: {
    type: PropTypes.string
  }
});
export default DatePicker;