import React from 'react';
import PropTypes from 'prop-types';
import { setDefaultProps } from '../_util/assist';
import { memo, useMemo, useEffect, useRef } from "react";
var prefixCls = 'r-textscroll';
var copyList = function copyList(list) {
  var arr = [];
  var listCopyNum;
  switch (list.length) {
    case 1:
      listCopyNum = 4;
      break;
    case 2:
      listCopyNum = 3;
      break;
    default:
      listCopyNum = 2;
  }
  for (var i = 0; i < listCopyNum; i++) {
    arr = arr.concat(list);
  }
  return {
    arr: arr,
    listCopyNum: listCopyNum
  };
};
var animate = function animate(_ref) {
  var target = _ref.target,
    gap = _ref.gap,
    maxScrollleft = _ref.maxScrollleft;
  var start = null;
  function step(timestamp) {
    if (!start) start = timestamp;
    var progress = timestamp - start;
    if (progress > gap) {
      target.scrollLeft = target.scrollLeft >= maxScrollleft ? 0 : target.scrollLeft + 1;
      start = timestamp;
    }
    window.requestAnimationFrame(step);
  }
  window.requestAnimationFrame(step);
};
var TextScroll = function TextScroll(_ref2) {
  var list = _ref2.list,
    prepend = _ref2.prepend,
    append = _ref2.append;
  var scrollbaRef = useRef();
  console.log('TextScroll mounted or updated');
  var _useMemo = useMemo(function () {
      return copyList(list);
    }, [list]),
    scrollList = _useMemo.arr,
    listCopyNum = _useMemo.listCopyNum;

  // setMaxScrollLeft
  useEffect(function () {
    var scrollbar = scrollbaRef.current;
    var maxScrollleft = scrollbar.scrollWidth / listCopyNum;
    animate({
      target: scrollbar,
      gap: 10,
      maxScrollleft: maxScrollleft
    });
  }, [listCopyNum]);
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls)
  }, prepend, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-scrollbar"),
    ref: scrollbaRef
  }, scrollList.map(function (item, index) {
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-item"),
      key: index
    }, item);
  })), append);
};
setDefaultProps(TextScroll, {
  list: {
    type: PropTypes.array,
    default: []
  },
  prepend: {
    type: PropTypes.node
  },
  append: {
    type: PropTypes.node
  }
});
export default /*#__PURE__*/memo(TextScroll);