"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _assist = require("../_util/assist");
var _withPreventScroll = _interopRequireDefault(require("../_hoc/withPreventScroll"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var prefixCls = 'r-flexfixed';
var FlexFixed = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var header = props.header,
    footer = props.footer,
    extra = props.extra,
    children = props.children,
    className = props.className,
    onScroll = props.onScroll,
    onScrollDebounce = props.onScrollDebounce,
    withPreventScroll = props.withPreventScroll,
    hideFooterOnKeyboardShow = props.hideFooterOnKeyboardShow;
  var doc = document.documentElement || document.body;
  var _useState = (0, _react.useState)(true),
    _useState2 = _slicedToArray(_useState, 2),
    showFooter = _useState2[0],
    setShowFooter = _useState2[1];
  var _useState3 = (0, _react.useState)(doc.clientHeight),
    _useState4 = _slicedToArray(_useState3, 1),
    docHeight = _useState4[0];
  var wrapCls = (0, _assist.classNames)([prefixCls, className]);
  var innerCls = "".concat(prefixCls, "-inner");
  var flexFixedRef = (0, _react.useRef)();
  var onMainTouchStart = function onMainTouchStart(e) {
    var main = e.currentTarget;
    main.maxScrollTop = main.scrollHeight - main.offsetHeight;
  };
  var onMainScroll = function onMainScroll(e) {
    var main = e.currentTarget;
    var scrollTop = main.scrollTop;
    var direction = '';
    if (scrollTop > main.prevScrollTop) {
      direction = 'up';
    } else if (scrollTop < main.prevScrollTop) {
      direction = 'down';
    }
    if (e.target.timer) clearTimeout(e.target.timer);
    e.target.timer = setTimeout(function () {
      onScrollDebounce && onScrollDebounce({
        scrollTop: main.scrollTop,
        maxScrollTop: main.maxScrollTop,
        direction: direction
      });
    }, 150);
    onScroll && onScroll({
      scrollTop: main.scrollTop,
      maxScrollTop: main.maxScrollTop,
      direction: direction
    });
    main.prevScrollTop = scrollTop;
  };

  // 阻止页面滚动
  (0, _react.useEffect)(function () {
    withPreventScroll && withPreventScroll.init({
      el: flexFixedRef.current
    });
  }, [withPreventScroll]);

  // 安卓键盘弹起时隐藏footer
  (0, _react.useEffect)(function () {
    if (hideFooterOnKeyboardShow) {
      var hideFooterOnScroll = function hideFooterOnScroll() {
        setShowFooter(doc.scrollTop === 0);
      };
      var hideFooterOnResize = function hideFooterOnResize() {
        setShowFooter(doc.clientHeight / docHeight > 0.8);
      };
      document.addEventListener('scroll', hideFooterOnScroll, false);
      window.addEventListener('resize', hideFooterOnResize, false);
      return function () {
        document.removeEventListener('scroll', hideFooterOnScroll, false);
        window.removeEventListener('resize', hideFooterOnResize, false);
      };
    }
  }, []);
  console.log('flexfixed mounted or updated');
  return /*#__PURE__*/_react.default.createElement("div", {
    className: wrapCls,
    ref: flexFixedRef
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: innerCls
  }, header && /*#__PURE__*/_react.default.createElement("header", null, header), /*#__PURE__*/_react.default.createElement("main", {
    className: "scroll-area",
    onScroll: onMainScroll,
    onTouchStart: onMainTouchStart
  }, children), footer && /*#__PURE__*/_react.default.createElement("footer", {
    style: {
      display: showFooter ? '' : 'none'
    }
  }, footer)), extra);
});
(0, _assist.setDefaultProps)(FlexFixed, {
  className: {
    type: _propTypes.default.string
  },
  header: {
    type: _propTypes.default.node
  },
  footer: {
    type: _propTypes.default.node
  },
  extra: {
    type: _propTypes.default.node
  },
  onScroll: {
    type: _propTypes.default.func
  },
  onScrollDebounce: {
    type: _propTypes.default.func
  },
  hideFooterOnKeyboardShow: {
    type: _propTypes.default.bool,
    default: true
  }
});
var _default = exports.default = (0, _withPreventScroll.default)( /*#__PURE__*/(0, _react.memo)(FlexFixed));