"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _asyncValidator = _interopRequireDefault(require("async-validator"));
var _assist = require("../_util/assist");
var _formContext = require("../form/formContext");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var prefixCls = 'r-input';
var Input = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Input, _React$PureComponent);
  var _super = _createSuper(Input);
  function Input(props) {
    var _this;
    _classCallCheck(this, Input);
    _this = _super.call(this, props);
    _this.onFieldInput = function (e) {
      var iptValue = e.target.value;
      var _this$props = _this.props,
        type = _this$props.type,
        maxlength = _this$props.maxlength,
        fixed = _this$props.fixed;
      _this.setState({
        validateState: '',
        validateMessage: ''
      });
      if (type === 'number') {
        var iptPrevValue = e.target.prevValue;
        // 修复input 属性为 number，maxlength不起作用
        if (maxlength && iptValue.length > maxlength) {
          e.target.value = iptValue.slice(0, maxlength);
        }
        // 限制小数位数
        var dotPos = iptValue.indexOf('.');
        if (dotPos > -1) {
          e.target.value = fixed > 0 ? iptValue.substring(0, dotPos + fixed + 1) : iptValue.substring(0, dotPos);
        }
        // 解决ios输入非数字时value清空问题
        var isBackSpace = e.nativeEvent && e.nativeEvent.inputType == 'deleteContentBackward';
        if (iptValue == '' && iptPrevValue != '' && !isBackSpace) {
          e.target.value = iptPrevValue;
        } else if (iptValue == '' && iptPrevValue == '') {
          // 第一个code为非数字
          e.target.value = '';
        }
        e.target.prevValue = e.target.value;
      } else if (type === 'tel') {
        e.target.value = telephoneClearNonNumbers(iptValue);
      } else if (type === 'IDCard') {
        e.target.value = IDCardClearNonNumbers(iptValue);
      }
      _this.setValue(e.target.value, function () {}, {
        event: e,
        from: 'input'
      });
    };
    // React的onInput和onChange并没有多少区别，其作用都是在用户持续输入的时候触发(先onInput,后onChange)，不在失去获取或者失去焦点的时候触发。
    _this.onFieldChange = function (e) {};
    _this.onFieldFocus = function (e) {
      var _this$props2 = _this.props,
        readonly = _this$props2.readonly,
        disabled = _this$props2.disabled,
        type = _this$props2.type,
        onFocus = _this$props2.onFocus;
      var iptValue = e.target.value;
      if (readonly || disabled) return;
      _this.setState({
        focused: true
      });
      onFocus({
        event: e,
        component: _assertThisInitialized(_this),
        value: iptValue
      });
      type === 'email' && _this.setState({
        showEmailPan: true
      });
      e.target.prevValue = e.target.value;
    };
    _this.onFieldBlur = function (e) {
      var iptValue = e.target.value;
      var _this$props3 = _this.props,
        onBlur = _this$props3.onBlur,
        type = _this$props3.type;
      e.persist();
      if (type === 'number') e.target.value = iptValue; // 防止失去焦点时最后一位是小数点，如"666."

      _this._state.blurTimer = setTimeout(function () {
        if (!_this._state.isMounted) return;
        _this.setValue(e.target.value, function () {
          if (!_this._state.validateDisabled) _this.validate('blur');
          _this._state.validateDisabled = false;
        }, {
          event: e,
          from: 'blur'
        });
        _this.setState({
          focused: false,
          showEmailPan: false
        });
      }, 200);
    };
    _this.onClear = function (e) {
      if (_this._state.blurTimer) clearTimeout(_this._state.blurTimer);
      _this.setValue('', function () {
        return _this.inputRef.current.focus();
      }, {
        event: e
      });
    };
    _this.onEmailClick = function (e) {
      var value = e.target.innerText;
      _this.inputRef.current.value = value;
    };
    _this.state = {
      value: props.value,
      prePropsValue: props.value,
      validateState: '',
      validateMessage: '',
      focused: false,
      showEmailPan: false
    };
    // 不需要驱动视图更新的数据放这里
    _this._state = {
      initialValue: '',
      validateDisabled: false,
      // true: blur时不做校验
      blurTimer: null,
      typing: false,
      // 键盘输入中文
      preValidateTime: '',
      isMounted: false
    };
    _this.inputRef = /*#__PURE__*/_react.default.createRef();
    _this.inputWrapRef = /*#__PURE__*/_react.default.createRef();
    return _this;
  }
  _createClass(Input, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      return /*#__PURE__*/_react.default.createElement(_formContext.Consumer, null, function (context) {
        _this2.form = context;
        console.log('Input mounted or updated');
        var _this2$props = _this2.props,
          title = _this2$props.title,
          name = _this2$props.name,
          type = _this2$props.type,
          prepend = _this2$props.prepend,
          append = _this2$props.append,
          maxlength = _this2$props.maxlength,
          disabled = _this2$props.disabled,
          readonly = _this2$props.readonly,
          autofocus = _this2$props.autofocus;
        var _this2$state = _this2.state,
          value = _this2$state.value,
          validateMessage = _this2$state.validateMessage;
        return /*#__PURE__*/_react.default.createElement("div", {
          className: _this2.wrapCls,
          ref: _this2.inputWrapRef
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: _this2.innerCls
        }, title && /*#__PURE__*/_react.default.createElement("label", {
          className: _this2.labelCls,
          style: _this2.labelStyle
        }, title), prepend && /*#__PURE__*/_react.default.createElement("div", {
          className: _this2.prependCls
        }, prepend), /*#__PURE__*/_react.default.createElement("div", {
          className: _this2.contentCls
        }, /*#__PURE__*/_react.default.createElement("input", _extends({
          type: _this2.inputType,
          name: name,
          value: value,
          pattern: type === 'number' ? 'number' : '',
          maxLength: maxlength,
          disabled: disabled,
          readOnly: readonly,
          autoFocus: autofocus,
          placeholder: _this2.placeholderText,
          className: _this2.inputCls,
          autoComplete: "off",
          spellCheck: "false"
        }, _this2.dataset(), {
          ref: _this2.inputRef,
          onInput: _this2.onFieldInput,
          onChange: _this2.onFieldChange,
          onFocus: _this2.onFieldFocus,
          onBlur: _this2.onFieldBlur
        })), _this2.showEditIcon && /*#__PURE__*/_react.default.createElement("div", {
          className: (0, _assist.classNames)(["input-edit", _this2.inputCls])
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: "placeholder"
        }, value), /*#__PURE__*/_react.default.createElement("span", {
          className: "edit-icon"
        })), _this2.showClear && /*#__PURE__*/_react.default.createElement("span", {
          className: _this2.clearCls,
          onClick: _this2.onClear
        }, /*#__PURE__*/_react.default.createElement("svg", {
          width: "14px",
          height: "14px",
          style: _this2.clearStyle,
          viewBox: "0 0 14 14",
          version: "1.1",
          xmlns: "http://www.w3.org/2000/svg",
          xmlnsXlink: "http://www.w3.org/1999/xlink"
        }, /*#__PURE__*/_react.default.createElement("g", {
          stroke: "none",
          strokeWidth: "1",
          fill: "none",
          fillRule: "evenodd"
        }, /*#__PURE__*/_react.default.createElement("g", {
          transform: "translate(-346.000000, -238.000000)",
          fill: _this2.clearStyle.color
        }, /*#__PURE__*/_react.default.createElement("g", {
          transform: "translate(346.000000, 238.000000)"
        }, /*#__PURE__*/_react.default.createElement("path", {
          d: "M7,0 C3.13354657,0 0,3.13354657 0,7 C0,10.8664534 3.13354657,14 7,14 C10.8664534,14 14,10.8664534 14,7 C14,3.13354657 10.8664534,0 7,0 Z M9.97021324,4.68998284 L7.66019608,7 L9.97021324,9.31001716 C10.1500343,9.49390441 10.1472721,9.78900245 9.96331618,9.97021324 C9.78215686,10.1472721 9.49115931,10.1472721 9.31001716,9.97021324 L7,7.66019608 L4.68998284,9.97021324 C4.50609559,10.1500343 4.21099755,10.1472721 4.02978676,9.96331618 C3.85272794,9.78215686 3.85272794,9.49115931 4.02978676,9.31001716 L6.33980392,7 L4.02978676,4.68998284 C3.84996569,4.50609559 3.85272794,4.21099755 4.03668382,4.02978676 C4.21784314,3.85272794 4.50884069,3.85272794 4.68998284,4.02978676 L7,6.33980392 L9.31001716,4.02978676 C9.49390441,3.84996569 9.78900245,3.85272794 9.97021324,4.03668382 C10.1472721,4.21784314 10.1472721,4.50884069 9.97021324,4.68998284 Z",
          id: "Fill-1"
        }))))))), append && /*#__PURE__*/_react.default.createElement("div", {
          className: _this2.appendCls
        }, append), _this2.showErrorMsg && /*#__PURE__*/_react.default.createElement("div", {
          className: _this2.errorCls
        }, validateMessage)), _this2.showEmailPanel && /*#__PURE__*/_react.default.createElement("div", {
          className: _this2.emailPanel
        }, _this2.filteredEmailList.map(function (emailSuffix, idx) {
          return /*#__PURE__*/_react.default.createElement("div", {
            className: _this2.emailPanelItem,
            key: idx,
            onClick: _this2.onEmailClick,
            dangerouslySetInnerHTML: {
              __html: (_this2.state.value.split('@')[0] + '@' + emailSuffix).replace(_this2.state.value, function (text) {
                return "<font>".concat(text, "</font>");
              })
            }
          });
        })));
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.form && this.form.addField(this);
      this._state.initialValue = this._state.prevValue = this.state.value;
      this._state.isMounted = true;
      this.$el = this.inputWrapRef.current;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.form && this.form.removeField(this);
      this._state.isMounted = false;
    }
  }, {
    key: "wrapCls",
    get: function get() {
      var _this$state = this.state,
        focused = _this$state.focused,
        value = _this$state.value;
      var _this$props4 = this.props,
        type = _this$props4.type,
        labelPosition = _this$props4.labelPosition,
        textPosition = _this$props4.textPosition,
        mode = _this$props4.mode,
        className = _this$props4.className,
        readonly = _this$props4.readonly,
        showEdit = _this$props4.showEdit;
      var _labelPosition = labelPosition || this.form && this.form.labelPosition || 'left';
      var _textPosition = textPosition || this.form && this.form.textPosition || 'left';
      var _mode = mode || this.form && this.form.mode || 'default';
      return (0, _assist.classNames)([this.form && 'form-item', prefixCls, "".concat(prefixCls, "-label-").concat(_labelPosition), "".concat(prefixCls, "-text-").concat(_textPosition), "".concat(prefixCls, "-mode-").concat(_mode), className, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-focused"), focused), "".concat(prefixCls, "-empty"), value === ''), "".concat(prefixCls, "-error"), this.showErrorMsg), "".concat(prefixCls, "-show-clear"), this.showClear), "".concat(prefixCls, "-hidden"), type === 'hidden'), "".concat(prefixCls, "-email"), type === 'email'), "".concat(prefixCls, "-required"), this.isRequired), "".concat(prefixCls, "-readonly"), !!readonly), "".concat(prefixCls, "-placeholder"), value === ''), "".concat(prefixCls, "-show-edit"), showEdit)]);
    }
  }, {
    key: "innerCls",
    get: function get() {
      return "".concat(prefixCls, "-inner");
    }
  }, {
    key: "labelCls",
    get: function get() {
      return "".concat(prefixCls, "-label");
    }
  }, {
    key: "labelStyle",
    get: function get() {
      var style = {};
      if (this.labelWidth || this.labelWidth === 0) {
        style.width = this.labelWidth;
      } else if (this.form && (this.form.labelWidth || this.form.labelWidth === 0)) {
        style.width = this.form.labelWidth;
      }
      return style;
    }
  }, {
    key: "prependCls",
    get: function get() {
      return "".concat(prefixCls, "-prepend");
    }
  }, {
    key: "appendCls",
    get: function get() {
      return "".concat(prefixCls, "-append");
    }
  }, {
    key: "placeholderText",
    get: function get() {
      return this.props.placeholder || this.form && this.form.placeholder || '';
    }
  }, {
    key: "clearStyle",
    get: function get() {
      var style = {
        color: '#C8C7CC'
      };
      return this.props.inputClearStyle || this.form && this.form.inputClearStyle || style;
    }
  }, {
    key: "contentCls",
    get: function get() {
      return "".concat(prefixCls, "-content");
    }
  }, {
    key: "inputCls",
    get: function get() {
      return "".concat(prefixCls, "-input");
    }
  }, {
    key: "clearCls",
    get: function get() {
      return "".concat(prefixCls, "-clear");
    }
  }, {
    key: "unitCls",
    get: function get() {
      return "".concat(prefixCls, "-unit");
    }
  }, {
    key: "showClear",
    get: function get() {
      return this.state.focused && String(this.state.value).length > 0;
    }
  }, {
    key: "errorCls",
    get: function get() {
      return "".concat(prefixCls, "-error-tip");
    }
  }, {
    key: "inputType",
    get: function get() {
      var type = this.props.type; // 'tel', 'number', 'text', 'IDCard'
      return type === 'IDCard' ? 'text' : type;
    }
  }, {
    key: "fieldRules",
    get: function get() {
      var _this$props5 = this.props,
        title = _this$props5.title,
        type = _this$props5.type,
        rules = _this$props5.rules;
      var defaultRules = [{
        required: true,
        message: "".concat(title, "\u4E0D\u80FD\u4E3A\u7A7A")
      }];
      if (type === 'IDCard') {
        defaultRules.push({
          validator: function validator(rule, value, callback) {
            if (!IDCardVerify(value)) {
              return new Error('身份证格式不正确');
            }
            callback();
          },
          trigger: 'blur'
        });
      } else if (type === 'email') {
        defaultRules.push({
          type: "email",
          message: "邮箱格式不正确",
          trigger: "blur"
        });
      }
      return [].concat(rules ? rules : defaultRules);
    }
  }, {
    key: "isRequired",
    get: function get() {
      return this.props.required && this.fieldRules.length > 0;
    }
  }, {
    key: "showErrorMsg",
    get: function get() {
      return this.state.validateState === 'error' && (this.form ? this.form.showMessage && this.props.showMessage : this.props.showMessage);
    }
  }, {
    key: "emailPanel",
    get: function get() {
      return "".concat(prefixCls, "-email-panel");
    }
  }, {
    key: "emailPanelItem",
    get: function get() {
      return "".concat(prefixCls, "-email-panel--item");
    }
  }, {
    key: "filteredEmailList",
    get: function get() {
      var emailList = this.props.emailList;
      var value = this.state.value;
      var emailSuffix = value.split('@')[1];
      var arr = [];
      if (!emailSuffix && value.length) {
        return emailList;
      }
      for (var i = 0; i < emailList.length; i++) {
        var email = emailList[i].replace('@', '');
        if (email.indexOf(emailSuffix) > -1) {
          arr.push(email);
        }
      }
      return arr;
    }
  }, {
    key: "showEmailPanel",
    get: function get() {
      var _this$state2 = this.state,
        value = _this$state2.value,
        showEmailPan = _this$state2.showEmailPan;
      var currEmailSuffix = String(value).split("@")[1];
      return this.props.type === 'email' && showEmailPan && (this.filteredEmailList.length > 1 || this.filteredEmailList.length === 1 && this.filteredEmailList[0] !== currEmailSuffix);
    }
  }, {
    key: "showEditIcon",
    get: function get() {
      var _this$state3 = this.state,
        focused = _this$state3.focused,
        value = _this$state3.value;
      var showEdit = this.props.showEdit;
      return showEdit && !focused && value != '';
    }
    // input添加dataset数据，外部可以通过e.target.dataset获取
  }, {
    key: "dataset",
    value: function dataset() {
      var obj = {};
      for (var key in this.props) {
        if (key.startsWith('data-')) obj[key] = this.props[key];
      }
      return obj;
    }
  }, {
    key: "getFilterRules",
    value: function getFilterRules(trigger) {
      return this.fieldRules.filter(function (rule) {
        return !rule.trigger || rule.trigger.indexOf(trigger) !== -1;
      });
    }
  }, {
    key: "validate",
    value: function validate(trigger) {
      var _this3 = this;
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
      var value = this.state.value;
      var initialValue = this._state.initialValue;
      var _this$props6 = this.props,
        name = _this$props6.name,
        title = _this$props6.title;
      var isMaskCode = initialValue.indexOf && initialValue.indexOf('*') > -1 && initialValue === value; // 掩码
      var rules = this.getFilterRules(trigger);
      if (!this.isRequired || isMaskCode) {
        callback();
        return true;
      }
      var prop = name || title || 'prop';
      var descriptor = {};
      descriptor[prop] = rules;
      var validator = new _asyncValidator.default(descriptor);
      var model = {};
      model[prop] = value;
      validator.validate(model, {
        first: true,
        suppressWarning: true,
        component: this
      }).then(function () {
        _this3.setState({
          validateState: 'success',
          validateMessage: ''
        });
        callback('');
      }).catch(function (_ref2) {
        var errors = _ref2.errors,
          fields = _ref2.fields;
        var errMsg = errors[0].message || '';
        _this3.setState({
          validateState: 'error',
          validateMessage: errMsg
        });
        callback(errMsg);
      });
    }
  }, {
    key: "resetField",
    value: function resetField() {
      this.setState({
        validateState: '',
        validateMessage: ''
      });
      this.setValue(this._state.initialValue, null, {
        from: 'reset',
        validateDisabled: true
      });
    }
    /* 获取表单数据 */
  }, {
    key: "getValue",
    value: function getValue() {
      return {
        name: this.props.name,
        value: this.state.value,
        title: this.props.title
      };
    }
  }, {
    key: "setValue",
    value: function setValue(value, callback) {
      var _this4 = this;
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var opts = Object.assign({
        event: null,
        component: this,
        value: value
      }, options);
      var from = options.from,
        validateDisabled = options.validateDisabled;
      if (validateDisabled) this._state.validateDisabled = true;
      this.setState({
        value: value
      }, function () {
        _this4.props.onChange(opts);
        _this4.form && _this4.form.onChange(opts);
        from === 'blur' && _this4.props.onBlur(opts);
        callback && callback.call(_this4);
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.value !== prevState.prePropsValue) {
        return {
          value: nextProps.value,
          prePropsValue: nextProps.value
        };
      }
      return null;
    }
  }]);
  return Input;
}(_react.default.PureComponent);
(0, _assist.setDefaultProps)(Input, {
  type: {
    type: _propTypes.default.string,
    default: 'text'
  },
  title: {
    type: _propTypes.default.node
  },
  value: {
    type: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
    default: ''
  },
  placeholder: {
    type: _propTypes.default.string
  },
  maxlength: {
    type: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
  },
  fixed: {
    type: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
  },
  disabled: {
    type: _propTypes.default.oneOf(['disabled', 1, 0, true, false])
  },
  readonly: {
    type: _propTypes.default.oneOf(['readonly', 1, 0, true, false])
  },
  autofocus: {
    type: _propTypes.default.oneOf(['autofocus', 1, 0, true, false])
  },
  emailList: {
    type: _propTypes.default.array,
    default: []
  },
  labelPosition: {
    type: _propTypes.default.oneOf(['left', 'right', 'top'])
  },
  labelWidth: {
    type: _propTypes.default.string
  },
  textPosition: {
    type: _propTypes.default.oneOf(['left', 'center', 'right'])
  },
  inputClearStyle: {
    type: _propTypes.default.object
  },
  showEdit: {
    type: _propTypes.default.bool
  },
  // 是否显示校验错误信息
  showMessage: {
    type: _propTypes.default.bool,
    default: true
  },
  // 校验规则
  rules: {
    type: _propTypes.default.array
  },
  required: {
    type: _propTypes.default.bool,
    default: true
  },
  onChange: {
    type: _propTypes.default.func,
    default: function _default() {}
  },
  onFocus: {
    type: _propTypes.default.func,
    default: function _default() {}
  },
  onBlur: {
    type: _propTypes.default.func,
    default: function _default() {}
  },
  mode: {
    type: _propTypes.default.string
  },
  append: {
    type: _propTypes.default.node
  }
});
function telephoneClearNonNumbers(str) {
  // 先把非数字的都替换掉，除了数字和.
  str = str.replace(/[^\d]/g, "");
  return str;
}
function IDCardClearNonNumbers(str) {
  // 身份证不超过15或18位数字，最后一位是X或者x，超过18截掉
  if (str.length > 18) {
    str = str.substr(0, 18);
  }
  if (str.length < 15 || str.length > 15 && str.length < 18) {
    str = str.replace(/[^\d]/g, "");
  }
  if (str.length == 15 || str.length == 18) {
    var str1 = str.substr(0, str.length - 1);
    var str2 = str.substr(str.length - 1, 1);
    str1 = str1.replace(/[^\d]/g, "");
    str2 = str2.replace(/[^\dXx]/g, "");
    str = str1 + str2;
  }
  return str;
}
function IDCardVerify(idcard) {
  var pass = false;
  var area = {
    11: "北京",
    12: "天津",
    13: "河北",
    14: "山西",
    15: "内蒙古",
    21: "辽宁",
    22: "吉林",
    23: "黑龙江",
    31: "上海",
    32: "江苏",
    33: "浙江",
    34: "安徽",
    35: "福建",
    36: "江西",
    37: "山东",
    41: "河南",
    42: "湖北",
    43: "湖南",
    44: "广东",
    45: "广西",
    46: "海南",
    50: "重庆",
    51: "四川",
    52: "贵州",
    53: "云南",
    54: "西藏",
    61: "陕西",
    62: "甘肃",
    63: "青海",
    64: "宁夏",
    65: "新疆",
    71: "台湾",
    81: "香港",
    82: "澳门",
    91: "国外"
  };
  var Y, JYM, ereg;
  var S, M;
  var idcardArray = [];
  idcardArray = idcard.split("");
  if (area[parseInt(idcard.substr(0, 2))] == null) {
    return false;
  }
  switch (idcard.length) {
    case 15:
      pass = false;
      break;
    case 18:
      if (parseInt(idcard.substr(6, 4)) % 4 == 0 || parseInt(idcard.substr(6, 4)) % 100 == 0 && parseInt(idcard.substr(6, 4)) % 4 == 0) {
        ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}[0-9Xx]$/; // 闰年出生日期的合法性正则表达式
      } else {
        ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}[0-9Xx]$/; // 平年出生日期的合法性正则表达式
      }

      if (ereg.test(idcard)) {
        S = (parseInt(idcardArray[0]) + parseInt(idcardArray[10])) * 7 + (parseInt(idcardArray[1]) + parseInt(idcardArray[11])) * 9 + (parseInt(idcardArray[2]) + parseInt(idcardArray[12])) * 10 + (parseInt(idcardArray[3]) + parseInt(idcardArray[13])) * 5 + (parseInt(idcardArray[4]) + parseInt(idcardArray[14])) * 8 + (parseInt(idcardArray[5]) + parseInt(idcardArray[15])) * 4 + (parseInt(idcardArray[6]) + parseInt(idcardArray[16])) * 2 + parseInt(idcardArray[7]) * 1 + parseInt(idcardArray[8]) * 6 + parseInt(idcardArray[9]) * 3;
        Y = S % 11;
        M = "F";
        JYM = "10X98765432";
        M = JYM.substr(Y, 1);
        if (M.toLowerCase() == idcardArray[17].toLowerCase()) {
          pass = true;
        } else {
          pass = false;
        }
      } else {
        pass = false;
      }
      break;
    default:
      pass = false;
      break;
  }
  ;
  return pass;
}
var _default2 = exports.default = Input;