"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setGlobalConfig = exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _modal = _interopRequireDefault(require("../modal"));
var _assist = require("../_util/assist");
var _loadingCircle = _interopRequireDefault(require("../icons/loading-circle"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var prefixCls = 'r-loading';
var globalConfig = {
  icon: /*#__PURE__*/_react.default.createElement(_loadingCircle.default, null)
};
var LoadingBox = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var defaultIcon = props.icon,
    defaultText = props.text,
    textStyle = props.textStyle;
  var _useState = (0, _react.useState)(defaultIcon),
    _useState2 = _slicedToArray(_useState, 2),
    icon = _useState2[0],
    _setIcon = _useState2[1];
  var _useState3 = (0, _react.useState)(defaultText),
    _useState4 = _slicedToArray(_useState3, 2),
    text = _useState4[0],
    _setText = _useState4[1];
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      setIcon: function setIcon(icon) {
        return _setIcon(icon);
      },
      setText: function setText(text) {
        return _setText(text);
      }
    };
  });
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, icon, text && /*#__PURE__*/_react.default.createElement("div", {
    className: "loading-text",
    style: textStyle
  }, text));
});
var createLoading = function createLoading() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _options = options,
    icon = _options.icon,
    text = _options.text,
    textStyle = _options.textStyle;
  var loadingBox;
  options = Object.assign({
    content: /*#__PURE__*/_react.default.createElement(LoadingBox, {
      icon: icon || globalConfig.icon,
      text: text || globalConfig.text,
      textStyle: textStyle,
      ref: function ref(el) {
        return loadingBox = el;
      }
    }),
    showCancel: false,
    showConfirm: false
  }, options);
  options.className = (0, _assist.classNames)([prefixCls, options.className]);
  var loading = _modal.default.create(options);
  loading.update = function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      icon = _ref.icon,
      text = _ref.text;
    if (icon) loadingBox.setIcon(icon);
    if (text) loadingBox.setText(text);
  };
  return loading;
};
var setGlobalConfig = exports.setGlobalConfig = function setGlobalConfig() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  globalConfig = Object.assign(globalConfig, options);
};
var _default = exports.default = createLoading;