"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _assist = require("../_util/assist");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var prefixCls = 'r-switch';
var Switch = function Switch(_ref) {
  var defaultChecked = _ref.defaultChecked,
    disabled = _ref.disabled,
    checkedChildren = _ref.checkedChildren,
    unCheckedChildren = _ref.unCheckedChildren,
    onChange = _ref.onChange;
  var _useState = (0, _react.useState)(defaultChecked),
    _useState2 = _slicedToArray(_useState, 2),
    onOff = _useState2[0],
    setOnOff = _useState2[1];
  var _useState3 = (0, _react.useState)(),
    _useState4 = _slicedToArray(_useState3, 2),
    maxLeft = _useState4[0],
    setMaxLeft = _useState4[1];
  var switchRef = (0, _react.useRef)();
  var circleRef = (0, _react.useRef)();
  console.log('Switch mounted or updated');
  (0, _react.useEffect)(function () {
    setOnOff(defaultChecked);
  }, [defaultChecked]);
  (0, _react.useEffect)(function () {
    setMaxLeft(switchRef.current.offsetWidth - circleRef.current.offsetWidth - 3);
  }, []);
  var wrapCls = (0, _assist.classNames)([prefixCls, _defineProperty({}, "".concat(prefixCls, "-checked"), onOff)]);
  var innerCls = "".concat(prefixCls, "-inner");
  var circleStyle = {
    left: onOff ? maxLeft + 'px' : ''
  };
  var onSwitchClick = function onSwitchClick(e) {
    if (disabled) return;
    var tempOnOff = !onOff;
    setOnOff(tempOnOff);
    onChange && onChange(tempOnOff, e);
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    className: wrapCls,
    ref: switchRef,
    onClick: onSwitchClick
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: innerCls
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "open"
  }, checkedChildren), /*#__PURE__*/_react.default.createElement("div", {
    className: "close"
  }, unCheckedChildren)), /*#__PURE__*/_react.default.createElement("div", {
    className: "circle",
    ref: circleRef,
    style: circleStyle
  }));
};
(0, _assist.setDefaultProps)(Switch, {
  defaultChecked: {
    type: _propTypes.default.bool,
    default: false
  },
  disabled: {
    type: _propTypes.default.bool
  },
  checkedChildren: {
    type: _propTypes.default.node
  },
  unCheckedChildren: {
    type: _propTypes.default.node
  },
  onChange: {
    type: _propTypes.default.func
  }
});
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(Switch);