"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _assist = require("../_util/assist");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var prefixCls = 'r-textscroll';
var copyList = function copyList(list) {
  var arr = [];
  var listCopyNum;
  switch (list.length) {
    case 1:
      listCopyNum = 4;
      break;
    case 2:
      listCopyNum = 3;
      break;
    default:
      listCopyNum = 2;
  }
  for (var i = 0; i < listCopyNum; i++) {
    arr = arr.concat(list);
  }
  return {
    arr: arr,
    listCopyNum: listCopyNum
  };
};
var animate = function animate(_ref) {
  var target = _ref.target,
    gap = _ref.gap,
    maxScrollleft = _ref.maxScrollleft;
  var start = null;
  function step(timestamp) {
    if (!start) start = timestamp;
    var progress = timestamp - start;
    if (progress > gap) {
      target.scrollLeft = target.scrollLeft >= maxScrollleft ? 0 : target.scrollLeft + 1;
      start = timestamp;
    }
    window.requestAnimationFrame(step);
  }
  window.requestAnimationFrame(step);
};
var TextScroll = function TextScroll(_ref2) {
  var list = _ref2.list,
    prepend = _ref2.prepend,
    append = _ref2.append;
  var scrollbaRef = (0, _react.useRef)();
  console.log('TextScroll mounted or updated');
  var _useMemo = (0, _react.useMemo)(function () {
      return copyList(list);
    }, [list]),
    scrollList = _useMemo.arr,
    listCopyNum = _useMemo.listCopyNum;

  // setMaxScrollLeft
  (0, _react.useEffect)(function () {
    var scrollbar = scrollbaRef.current;
    var maxScrollleft = scrollbar.scrollWidth / listCopyNum;
    animate({
      target: scrollbar,
      gap: 10,
      maxScrollleft: maxScrollleft
    });
  }, [listCopyNum]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls)
  }, prepend, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls, "-scrollbar"),
    ref: scrollbaRef
  }, scrollList.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "".concat(prefixCls, "-item"),
      key: index
    }, item);
  })), append);
};
(0, _assist.setDefaultProps)(TextScroll, {
  list: {
    type: _propTypes.default.array,
    default: []
  },
  prepend: {
    type: _propTypes.default.node
  },
  append: {
    type: _propTypes.default.node
  }
});
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(TextScroll);